/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.mangue.client.gui.individu;

import java.awt.BorderLayout;
import java.util.Date;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.mangue.common.utilities.CocktailConstantes;
import org.cocktail.application.common.utilities.CocktailFormats;
import org.cocktail.mangue.common.utilities.CocktailIcones;
import org.cocktail.mangue.modele.mangue.individu.EODif;
import org.cocktail.mangue.modele.mangue.individu.EODifDetail;

import com.webobjects.eointerface.EODisplayGroup;


/**
 *
 * @author  cpinsard
 */
public class CDifView extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6195866169790317637L;
	protected EODisplayGroup eod, eodDetail;
	protected ZEOTable myEOTable, myEOTableDetail;
	protected ZEOTableModel myTableModel, myTableModelDetail;
	protected TableSorter myTableSorter, myTableSorterDetail;

	/** Creates new form TemplateJDialog */
	public CDifView(java.awt.Frame parent, EODisplayGroup dg, EODisplayGroup dgDetail , boolean modal) {

		eod = dg;
		eodDetail = dgDetail;
		initComponents();
		initGui();
		
	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewCDif = new javax.swing.JPanel();
        viewSaisie = new javax.swing.JPanel();
        btnValider = new javax.swing.JButton();
        btnAnnuler = new javax.swing.JButton();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        tfCredit = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        tfDateDebut = new javax.swing.JTextField();
        jLabel19 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        tfDebit = new javax.swing.JTextField();
        jLabel22 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        tfBalance = new javax.swing.JTextField();
        jLabel24 = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        tfDateFin = new javax.swing.JTextField();
        popupAnnees = new javax.swing.JComboBox();
        viewTableDetail = new javax.swing.JPanel();
        btnModifier = new javax.swing.JButton();
        btnSupprimer = new javax.swing.JButton();
        btnAjouter = new javax.swing.JButton();
        viewTable = new javax.swing.JPanel();
        btnAjouterDetail = new javax.swing.JButton();
        btnModifierDetail = new javax.swing.JButton();
        btnSupprimerDetail = new javax.swing.JButton();
        btnRecalculer = new javax.swing.JButton();
        btnToutRecalculer = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("FORMATIONS");

        viewSaisie.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValider.setText("Valider");
        btnValider.setToolTipText("Valider la saisie");
        btnValider.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValiderActionPerformed(evt);
            }
        });

        btnAnnuler.setText("Annuler");
        btnAnnuler.setToolTipText("Annuler la saisie");
        btnAnnuler.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAnnulerActionPerformed(evt);
            }
        });

        jLabel17.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel17.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel17.setText("Année");

        jLabel18.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel18.setText("Crédit cumulé ");

        tfCredit.setEditable(false);
        tfCredit.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfCredit.setToolTipText("");

        jLabel20.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel20.setText("Début");

        tfDateDebut.setEditable(false);
        tfDateDebut.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfDateDebut.setToolTipText("");

        jLabel19.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel19.setText("Heures");

        jLabel21.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel21.setText("Débit cumulé");

        tfDebit.setEditable(false);
        tfDebit.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfDebit.setToolTipText("");

        jLabel22.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel22.setText("Heures");

        jLabel23.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel23.setText("Balance");

        tfBalance.setEditable(false);
        tfBalance.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfBalance.setToolTipText("");

        jLabel24.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel24.setText("Heures");

        jLabel25.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel25.setText("Fin");

        tfDateFin.setEditable(false);
        tfDateFin.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfDateFin.setToolTipText("");

        popupAnnees.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        org.jdesktop.layout.GroupLayout viewSaisieLayout = new org.jdesktop.layout.GroupLayout(viewSaisie);
        viewSaisie.setLayout(viewSaisieLayout);
        viewSaisieLayout.setHorizontalGroup(
            viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(viewSaisieLayout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewSaisieLayout.createSequentialGroup()
                        .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(jLabel18, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(jLabel17, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 82, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(viewSaisieLayout.createSequentialGroup()
                                .add(tfCredit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 73, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jLabel19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 58, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(popupAnnees, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 131, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(jLabel20, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(jLabel21, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(tfDateDebut)
                            .add(tfDebit, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 73, Short.MAX_VALUE))
                        .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(viewSaisieLayout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jLabel22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 58, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jLabel23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 68, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(viewSaisieLayout.createSequentialGroup()
                                .add(47, 47, 47)
                                .add(jLabel25, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(tfDateFin)
                            .add(tfBalance, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 73, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 55, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(79, 79, 79))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, viewSaisieLayout.createSequentialGroup()
                        .add(btnAnnuler, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 96, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnValider, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 96, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        viewSaisieLayout.setVerticalGroup(
            viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(viewSaisieLayout.createSequentialGroup()
                .add(18, 18, 18)
                .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel17)
                    .add(tfDateDebut, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel20)
                    .add(jLabel25)
                    .add(tfDateFin, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(popupAnnees, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel18)
                    .add(tfCredit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel19)
                    .add(jLabel21)
                    .add(tfDebit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel22)
                    .add(jLabel23)
                    .add(tfBalance, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel24))
                .add(18, 18, 18)
                .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnAnnuler)
                    .add(btnValider))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        viewTableDetail.setLayout(new java.awt.BorderLayout());

        btnModifier.setToolTipText("Modification");

        btnSupprimer.setToolTipText("Suppression");

        btnAjouter.setToolTipText("Ajout");

        viewTable.setLayout(new java.awt.BorderLayout());

        btnAjouterDetail.setToolTipText("Ajout d'un détail");

        btnModifierDetail.setToolTipText("Modification");

        btnSupprimerDetail.setToolTipText("Suppression");

        btnRecalculer.setToolTipText("Recalcul du DIF sélectionné");

        btnToutRecalculer.setToolTipText("Tout recalculer pour l'agent sélectionné");

        org.jdesktop.layout.GroupLayout viewCDifLayout = new org.jdesktop.layout.GroupLayout(viewCDif);
        viewCDif.setLayout(viewCDifLayout);
        viewCDifLayout.setHorizontalGroup(
            viewCDifLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(viewCDifLayout.createSequentialGroup()
                .addContainerGap()
                .add(viewCDifLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewSaisie, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, viewCDifLayout.createSequentialGroup()
                        .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 735, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewCDifLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(viewCDifLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(btnSupprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(btnModifier, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(btnAjouter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(btnRecalculer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnToutRecalculer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, viewCDifLayout.createSequentialGroup()
                        .add(viewTableDetail, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 735, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewCDifLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(btnSupprimerDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnModifierDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnAjouterDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        viewCDifLayout.setVerticalGroup(
            viewCDifLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(viewCDifLayout.createSequentialGroup()
                .addContainerGap()
                .add(viewCDifLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewCDifLayout.createSequentialGroup()
                        .add(btnAjouter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnModifier, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnSupprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnRecalculer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnToutRecalculer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 177, Short.MAX_VALUE))
                .add(11, 11, 11)
                .add(viewSaisie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(20, 20, 20)
                .add(viewCDifLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewCDifLayout.createSequentialGroup()
                        .add(btnAjouterDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnModifierDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnSupprimerDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(viewTableDetail, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 200, Short.MAX_VALUE))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(28, 28, 28)
                .add(viewCDif, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(50, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(30, 30, 30)
                .add(viewCDif, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(74, Short.MAX_VALUE))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-877)/2, (screenSize.height-703)/2, 877, 703);
    }// </editor-fold>//GEN-END:initComponents

	private void btnValiderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValiderActionPerformed
		// TODO add your handling code here:
	}//GEN-LAST:event_btnValiderActionPerformed

	private void btnAnnulerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAnnulerActionPerformed
		// TODO add your handling code here:
	}//GEN-LAST:event_btnAnnulerActionPerformed

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				CDifView dialog = new CDifView(new javax.swing.JFrame(), null, null, true);
				dialog.addWindowListener(new java.awt.event.WindowAdapter() {
					public void windowClosing(java.awt.event.WindowEvent e) {
						System.exit(0);
					}
				});
				dialog.setVisible(true);
			}
		});
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAjouter;
    private javax.swing.JButton btnAjouterDetail;
    protected javax.swing.JButton btnAnnuler;
    private javax.swing.JButton btnModifier;
    private javax.swing.JButton btnModifierDetail;
    private javax.swing.JButton btnRecalculer;
    private javax.swing.JButton btnSupprimer;
    private javax.swing.JButton btnSupprimerDetail;
    private javax.swing.JButton btnToutRecalculer;
    protected javax.swing.JButton btnValider;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JComboBox popupAnnees;
    protected javax.swing.JTextField tfBalance;
    protected javax.swing.JTextField tfCredit;
    protected javax.swing.JTextField tfDateDebut;
    protected javax.swing.JTextField tfDateFin;
    protected javax.swing.JTextField tfDebit;
    private javax.swing.JPanel viewCDif;
    private javax.swing.JPanel viewSaisie;
    private javax.swing.JPanel viewTable;
    private javax.swing.JPanel viewTableDetail;
    // End of variables declaration//GEN-END:variables

    public void setListeAnnees(Integer[] listeExercices) {

        popupAnnees.removeAllItems();
        popupAnnees.addItem("");
        
        for (int i=0;i<listeExercices.length;i++) {
        	popupAnnees.addItem(listeExercices[i]);
        }        	
    }

	private void initGui() {

		btnAjouter.setIcon(CocktailIcones.ICON_ADD);
		btnModifier.setIcon(CocktailIcones.ICON_UPDATE);
		btnSupprimer.setIcon(CocktailIcones.ICON_DELETE);

		btnAjouterDetail.setIcon(CocktailIcones.ICON_ADD);
		btnModifierDetail.setIcon(CocktailIcones.ICON_UPDATE);
		btnSupprimerDetail.setIcon(CocktailIcones.ICON_DELETE);

		btnValider.setIcon(CocktailIcones.ICON_VALID);
		btnAnnuler.setIcon(CocktailIcones.ICON_CANCEL);
		btnRecalculer.setIcon(CocktailIcones.ICON_CALCULATE_16);
		btnToutRecalculer.setIcon(CocktailIcones.ICON_REFRESH_16);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, EODif.ANNEE_CALCUL_KEY, "Année", 75);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EODif.DATE_DEBUT_KEY, "Début", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(CocktailFormats.FORMAT_DATE_DDMMYYYY);
		col.setColumnClass(Date.class);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EODif.DATE_FIN_KEY, "Fin", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(CocktailFormats.FORMAT_DATE_DDMMYYYY);
		col.setColumnClass(Date.class);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EODif.DIF_CREDIT_ANNUEL_KEY, "Crédit", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EODif.DIF_DEBIT_ANNUEL_KEY, "Débit", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EODif.DIF_CREDIT_CUMULE_KEY, "Cr Cumulé", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EODif.DIF_DEBIT_CUMULE_KEY, "Débit Cumulé", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EODif.BALANCE_KEY, "Balance", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);

		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

		myEOTable.setBackground(CocktailConstantes.BG_COLOR_WHITE);
		myEOTable.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);

		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);

		
		
		myCols = new Vector<ZEOTableModelColumn>();

		col = new ZEOTableModelColumn(eodDetail, EODifDetail.DATE_DEBUT_KEY, "Début", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(CocktailFormats.FORMAT_DATE_DDMMYYYY);
		col.setColumnClass(Date.class);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodDetail, EODifDetail.DATE_FIN_KEY, "Fin", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(CocktailFormats.FORMAT_DATE_DDMMYYYY);
		col.setColumnClass(Date.class);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodDetail, EODifDetail.DIF_DETAIL_LIBELLE_KEY, "Formation", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodDetail, EODifDetail.DIF_DETAIL_DEBIT_KEY, "Débit", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);

		myTableModelDetail = new ZEOTableModel(eodDetail, myCols);
		myTableSorterDetail = new TableSorter(myTableModelDetail);

		myEOTableDetail = new ZEOTable(myTableSorterDetail);
		//myEOTable.addListener(myListenerContrat);
		myTableSorterDetail.setTableHeader(myEOTableDetail.getTableHeader());		

		myEOTableDetail.setBackground(CocktailConstantes.BG_COLOR_WHITE);
		myEOTableDetail.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableDetail.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);

		viewTableDetail.setLayout(new BorderLayout());
		viewTableDetail.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableDetail.removeAll();
		viewTableDetail.add(new JScrollPane(myEOTableDetail), BorderLayout.CENTER);

		
		
	}

	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}

	public ZEOTable getMyEOTableDetail() {
		return myEOTableDetail;
	}

	public void setMyEOTableDetail(ZEOTable myEOTableDetail) {
		this.myEOTableDetail = myEOTableDetail;
	}

	public javax.swing.JButton getBtnAjouter() {
		return btnAjouter;
	}

	public void setBtnAjouter(javax.swing.JButton btnAjouter) {
		this.btnAjouter = btnAjouter;
	}

	public javax.swing.JButton getBtnAjouterDetail() {
		return btnAjouterDetail;
	}

	public void setBtnAjouterDetail(javax.swing.JButton btnAjouterDetail) {
		this.btnAjouterDetail = btnAjouterDetail;
	}

	public javax.swing.JButton getBtnAnnuler() {
		return btnAnnuler;
	}

	public void setBtnAnnuler(javax.swing.JButton btnAnnuler) {
		this.btnAnnuler = btnAnnuler;
	}

	public javax.swing.JButton getBtnModifier() {
		return btnModifier;
	}

	public void setBtnModifier(javax.swing.JButton btnModifier) {
		this.btnModifier = btnModifier;
	}

	public javax.swing.JButton getBtnModifierDetail() {
		return btnModifierDetail;
	}

	public void setBtnModifierDetail(javax.swing.JButton btnModifierDetail) {
		this.btnModifierDetail = btnModifierDetail;
	}

	public javax.swing.JButton getBtnSupprimer() {
		return btnSupprimer;
	}

	public void setBtnSupprimer(javax.swing.JButton btnSupprimer) {
		this.btnSupprimer = btnSupprimer;
	}

	public javax.swing.JButton getBtnSupprimerDetail() {
		return btnSupprimerDetail;
	}

	public void setBtnSupprimerDetail(javax.swing.JButton btnSupprimerDetail) {
		this.btnSupprimerDetail = btnSupprimerDetail;
	}

	public javax.swing.JButton getBtnValider() {
		return btnValider;
	}

	public void setBtnValider(javax.swing.JButton btnValider) {
		this.btnValider = btnValider;
	}

	public javax.swing.JComboBox getPopupAnnees() {
		return popupAnnees;
	}

	public void setPopupAnnees(javax.swing.JComboBox popupAnnees) {
		this.popupAnnees = popupAnnees;
	}

	public javax.swing.JTextField getTfBalance() {
		return tfBalance;
	}

	public void setTfBalance(javax.swing.JTextField tfBalance) {
		this.tfBalance = tfBalance;
	}

	public javax.swing.JTextField getTfCredit() {
		return tfCredit;
	}

	public void setTfCredit(javax.swing.JTextField tfCredit) {
		this.tfCredit = tfCredit;
	}

	public javax.swing.JTextField getTfDateDebut() {
		return tfDateDebut;
	}

	public void setTfDateDebut(javax.swing.JTextField tfDateDebut) {
		this.tfDateDebut = tfDateDebut;
	}

	public javax.swing.JTextField getTfDateFin() {
		return tfDateFin;
	}

	public void setTfDateFin(javax.swing.JTextField tfDateFin) {
		this.tfDateFin = tfDateFin;
	}

	public javax.swing.JTextField getTfDebit() {
		return tfDebit;
	}

	public void setTfDebit(javax.swing.JTextField tfDebit) {
		this.tfDebit = tfDebit;
	}

	public javax.swing.JPanel getViewCDif() {
		return viewCDif;
	}

	public void setViewCDif(javax.swing.JPanel viewCDif) {
		this.viewCDif = viewCDif;
	}

	public javax.swing.JButton getBtnRecalculer() {
		return btnRecalculer;
	}

	public void setBtnRecalculer(javax.swing.JButton btnRecalculer) {
		this.btnRecalculer = btnRecalculer;
	}

	public javax.swing.JButton getBtnToutRecalculer() {
		return btnToutRecalculer;
	}

	public void setBtnToutRecalculer(javax.swing.JButton btnToutRecalculer) {
		this.btnToutRecalculer = btnToutRecalculer;
	}

	



}
